var SandboxedModule = require('sandboxed-module'),
    assert = require('assert'),
    fs = require('fs'),
    _ = require('lodash'),
    _str = require('underscore.string'),
    data = fs.readFileSync(__dirname + '/data.txt', 'utf-8'),
    dataEnc = fs.readFileSync(__dirname + '/data.ssl'),
    priv = fs.readFileSync(__dirname + '/private.pem'),
    pub = fs.readFileSync(__dirname + '/public.pem'),
    translator;

translator = SandboxedModule.require('../lib/rsa-translator', {
    'requires': {
        'lodash': _,
        'underscore.string': _str,
        'fs': fs
    },
    'globals': {
    },
    'locals': {
    }
});

describe('rsa-translator', function() {

    describe('generateKeyPair', function() {

        it('should pass a key pair object to the provided callback function', function(done) {

            translator.generateKeyPair(null, function(err, pair) {
                assert(!err);
                done();
            });

        });

    });

    describe('decrypt', function() {

        it('should pass the decrypted data to the provided callback function', function(done) {

            translator.decrypt(dataEnc, {
                'private_key': priv
            }, function(err, result) {
                assert(!err);
                assert(result.indexOf(data) === 0);
                done();
            });

        });

    });

    describe('encrypt', function() {

        it('should pass the encrypted data to the provided callback function', function(done) {

            translator.encrypt(data, {
                'public_key': pub
            }, function(err, result) {
                assert(!err);
                assert(result);
                done();
            });

        });

    });

});
